/*
 * EasySHP ESRI  SHP Ӽ   DBF óϱ  ڹ Ŭ Դϴ.
 * EasySHP   ϸ  Java ̺귯Դϴ.
 * Geometry JTS ̺귯 Ͽ Geometry  پ   ״   ֽϴ.
 * 
 * ۱ (C) 2011 (GeoService)
 * 
 *  ̺귯  ƮԴϴ.
 * GNU LGPL    /ְų   ֽϴ.
 *  Ʈ Կ ־ ߻ϴ  å ʽϴ.
 * 
 *  ڼ  ؼ  ó  Ͻñ ٶϴ.
 * 
 *      hjkim@geoservice.co.kr
 *      www.gisdeveloper.co.kr
 * Ȩ  www.geoservice.co.kr 
 * 
 * մϴ.
 */

package geoservice.easyshp.dbf;

import java.util.HashMap;
import java.util.Map;

/**
 * DBF ϴ Row  Ŭ
 * 
 * @author GEOSERVICE
 * @version 1.0
 */
public class RowSetDBF {
	private Map<Integer, RowDBF> rows = new HashMap<Integer, RowDBF>(); // DBF ϴ row ÷
	private AccessDBF control = null; // DBF Ϸκ row ʵ尪 б  Ʈ
	
	/**
	 * 
	 * @param control DBF Ϸκ row ʵ尪 б  Ʈ
	 */
	public RowSetDBF(AccessDBF control) {
		this.control = control;
	}
	
	/**
	 * DBF ϴ row  ȯ
	 * @return
	 */
	public int getRowCount() {
		return control.getRowInitCount();
	}
	
	/**
	 * fid شϴ row ޸𸮿 
	 * <b>Ϸκ ϴ  ƴ ޸ 󿡼 </b>
	 * @param fid ϰ ϴ row fid(1 )
	 */
	public void deleteRow(int fid) {
		rows.remove(fid);
	}
	
	/**
	 * row ޸𸮿 ø
	 * @param row ޸𸮿 ø row
	 * @return ̹ ޸  ö ִ row  <code>false</code> ȯ
	 */
	public boolean addRow(RowDBF row) {
		int fid = row.getFID();
		boolean bExist = rows.containsKey(fid);
		if(bExist) {
			return false;
		} else {
			rows.put(fid, row);
			return true;
		}
	}
	
	/**
	 * fid شϴ row 
	 * <b>row  ʵ尪 б ؼ load ż带 ȣؾ<b>
	 * @see RowDBF#load()
	 * @param fid  ϴ row id
	 * @return fid شϴ row
	 */
	public RowDBF getRow(int fid) {
		RowDBF row = rows.get(fid);
		if(row == null) {
			row = new RowDBF(fid, control);
		}

		return row;
	}
}